<?xml version="1.0" encoding="shift_jis"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!---->
<!--   \֘ÃO[o` -->
<!---->

<!-- J_[̓j̈ʒuE[ۂ -->
<xsl:variable name="sunend" select="true()"/>


<!-- J_[̃wb_̃ftHg -->
<xsl:attribute-set name="a_th">
	<xsl:attribute name="width">120</xsl:attribute>
</xsl:attribute-set>


<!-- J_[̖{̃̕ftHg -->
<xsl:attribute-set name="a_td">
	<xsl:attribute name="height">80</xsl:attribute>
	<xsl:attribute name="valign">top</xsl:attribute>
</xsl:attribute-set>


<!-- Gg̃}EXCxg -->
<xsl:attribute-set name="a_entry">
	<xsl:attribute name="onMouseOver">style.color='blue'</xsl:attribute>
	<xsl:attribute name="onMouseOut">style.color='black'</xsl:attribute>
</xsl:attribute-set>



<!---->
<!--   \\XSLTev[g -->
<!---->

<!--
\\Gg[|Cg
OJavaScriptƁAAgenda XMLt@Cǂݍ݁ACĂяoB
//-->
<xsl:template name="schedule">
	<xsl:param name="shift"/>

	<html>
	<head>
		<script src="schedule.js"/>
		<link rel="stylesheet" type="text/css" href="schedule.css"/>
	</head>
	<body>
		<xsl:apply-templates select="document('../agenda.xml')/epocAgenda">
			<xsl:with-param name="shift" select="$shift"/>
		</xsl:apply-templates>
	</body>
	</html>
</xsl:template>



<!--
\\C
HTMLbody^Oe𐶐B
XMLf[^exported^O쐬oA\NE߂B
//-->
<xsl:template match="epocAgenda">
	<xsl:param name="shift"/>

	<xsl:variable name="year">
		<xsl:value-of select="substring(@createDate,1,4)"/>
	</xsl:variable>
	<xsl:variable name="month">
		<xsl:value-of select="substring(@createDate,6,2)"/>
	</xsl:variable>
	<xsl:variable name="y" select="floor($year+($month+$shift - 1) div 12)"/>
	<xsl:variable name="m" select="($month+$shift+1199) mod 12+1"/>

	<table border="0">
		<tr class="title">
			<xsl:call-template name="title">
				<xsl:with-param name="y" select="$y"/>
				<xsl:with-param name="m" select="$m"/>
				<xsl:with-param name="shift" select="$shift"/>
			</xsl:call-template>
		</tr>
		<tr>
			<td colspan="3">
				<xsl:call-template name="calender">
					<xsl:with-param name="y" select="$y"/>
					<xsl:with-param name="m" select="$m"/>
				</xsl:call-template>
			</td>
		</tr>
	</table>
</xsl:template>



<!--
^Cg
NE̕\ƁA挎EpXMLt@Cւ̃N𐶐B
//-->
<xsl:template name="title">
	<xsl:param name="y"/>
	<xsl:param name="m"/>
	<xsl:param name="shift"/>

	<th>
		<xsl:if test="$shift&gt; -12">
			<a>
				<xsl:attribute name="href">
					month<xsl:value-of select="$shift - 1"/>.xml
				</xsl:attribute>
				<xsl:text>&lt;&lt;</xsl:text>
			</a>
		</xsl:if>
	</th>
	<th>
		<a>
			<xsl:attribute name="href">month0.xml</xsl:attribute>
			<xsl:value-of select="$y"/> / <xsl:value-of select="$m"/>
		</a>
	</th>
	<th>
		<xsl:if test="$shift&lt;12">
			<a>
				<xsl:attribute name="href">
					month<xsl:value-of select="$shift+1"/>.xml
				</xsl:attribute>
				<xsl:text>&gt;&gt;</xsl:text>
			</a>
		</xsl:if>
	</th>
</xsl:template>



<!--
J_[
oƃJ_[{̂ĂяoB
//-->
<xsl:template name="calender">
	<xsl:param name="y"/>
	<xsl:param name="m"/>

	<table border="1" class="body">
		<tr>
			<xsl:call-template name="calhead">
				<xsl:with-param name="dow" select="$sunend*1"/>
			</xsl:call-template>
		</tr>
		<xsl:call-template name="calbody">
			<xsl:with-param name="y" select="$y"/>
			<xsl:with-param name="m" select="$m"/>
		</xsl:call-template>
	</table>
</xsl:template>



<!--
J_[̌o
ċAĂяoɂA7񃋁[vB
//-->
<xsl:template name="calhead">
	<xsl:param name="dow"/>

	<xsl:if test="$dow&lt;(7+$sunend)">
		<th class="week" xsl:use-attribute-sets="a_th">
			<xsl:choose>
				<xsl:when test="$dow=1">Mon</xsl:when>
				<xsl:when test="$dow=2">Tue</xsl:when>
				<xsl:when test="$dow=3">Wed</xsl:when>
				<xsl:when test="$dow=4">Thu</xsl:when>
				<xsl:when test="$dow=5">Fri</xsl:when>
				<xsl:when test="$dow=6">
					<xsl:attribute name="class">sat</xsl:attribute>Sat
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="class">sun</xsl:attribute>Sun
				</xsl:otherwise>
			</xsl:choose>
		</th>

		<xsl:call-template name="calhead">
			<xsl:with-param name="dow" select="$dow+1"/>
		</xsl:call-template>
	</xsl:if>
</xsl:template>



<!--
J_[{
ZelleřjZoB
邤N𔻒肵AZoB
J_[Tɕ鏈ĂяoB
//-->
<xsl:template name="calbody">
	<xsl:param name="y"/>
	<xsl:param name="m"/>

	<xsl:variable name="yy" select="$y - ($y&lt;3)"/>
	<xsl:variable name="mm" select="$m + ($y&lt;3)*12"/>
	<xsl:variable name="y4" select="floor($yy div 4)"/>
	<xsl:variable name="y100" select="floor($yy div 100)"/>
	<xsl:variable name="y400" select="floor($yy div 400)"/>
	<xsl:variable name="offset" select="($yy+$y4 - $y100+$y400+floor(2.6*$mm+1.6)+0) mod 7+1"/>

	<xsl:variable name="u" select="not($y mod 4) and ($y mod 100) or not($y mod 1000)"/>
	<xsl:variable name="big" select="(($m mod 2) and ($m&lt;8)) or (not($m mod 2) and ($m&gt;7))"/>
	<xsl:variable name="last" select="31+$big - ($m=2)*2+($m=2)*$u"/>

	<xsl:call-template name="count_week">
		<xsl:with-param name="y" select="$y"/>
		<xsl:with-param name="m" select="$m"/>
		<xsl:with-param name="w" select="0"/>
		<xsl:with-param name="offset" select="$offset"/>
		<xsl:with-param name="last" select="$last"/>
	</xsl:call-template>
</xsl:template>



<!--
J_[Tɕ鏈
ċAĂяoɂAŏIT܂Ń[vB
eTɏTPʂ̏ĂяoB
//-->
<xsl:template name="count_week">
	<xsl:param name="y"/>
	<xsl:param name="m"/>
	<xsl:param name="w"/>
	<xsl:param name="offset"/>
	<xsl:param name="last"/>

	<xsl:variable name="top" select="($w*7) - $offset+$sunend+1"/>
	<xsl:if test="$top&lt;$last">
		<xsl:if test="$top&gt;-6">
			<xsl:call-template name="week">
				<xsl:with-param name="y" select="$y"/>
				<xsl:with-param name="m" select="$m"/>
				<xsl:with-param name="w" select="$w"/>
				<xsl:with-param name="offset" select="$offset"/>
				<xsl:with-param name="last" select="$last"/>
			</xsl:call-template>
		</xsl:if>

		<xsl:call-template name="count_week">
			<xsl:with-param name="y" select="$y"/>
			<xsl:with-param name="m" select="$m"/>
			<xsl:with-param name="w" select="$w+1"/>
			<xsl:with-param name="offset" select="$offset"/>
			<xsl:with-param name="last" select="$last"/>
		</xsl:call-template>
	</xsl:if>
</xsl:template>



<!--
TPʂ̏
TPʂɕ鏈ĂяoB
//-->
<xsl:template name="week">
	<xsl:param name="y"/>
	<xsl:param name="m"/>
	<xsl:param name="w"/>
	<xsl:param name="offset"/>
	<xsl:param name="last"/>

	<tr xsl:use-attribute-sets="a_td">
		<xsl:call-template name="count_day">
			<xsl:with-param name="y" select="$y"/>
			<xsl:with-param name="m" select="$m"/>
			<xsl:with-param name="w" select="$w"/>
			<xsl:with-param name="d" select="1"/>
			<xsl:with-param name="offset" select="$offset"/>
			<xsl:with-param name="last" select="$last"/>
			<xsl:with-param name="dow" select="$sunend*1"/>
		</xsl:call-template>
	</tr>
</xsl:template>



<!--
TPʂɕ鏈
ċAĂяoɂA7񃋁[v񂷁B
//-->
<xsl:template name="count_day">
	<xsl:param name="y"/>
	<xsl:param name="m"/>
	<xsl:param name="w"/>
	<xsl:param name="d"/>
	<xsl:param name="offset"/>
	<xsl:param name="last"/>
	<xsl:param name="dow"/>

	<xsl:if test="$d&lt;8">
		<xsl:call-template name="day">
			<xsl:with-param name="y" select="$y"/>
			<xsl:with-param name="m" select="$m"/>
			<xsl:with-param name="w" select="$w"/>
			<xsl:with-param name="d" select="$w*7+$d+$sunend - $offset"/>
			<xsl:with-param name="last" select="$last"/>
			<xsl:with-param name="dow" select="$dow"/>
		</xsl:call-template>
		<xsl:call-template name="count_day">
			<xsl:with-param name="y" select="$y"/>
			<xsl:with-param name="m" select="$m"/>
			<xsl:with-param name="w" select="$w"/>
			<xsl:with-param name="d" select="$d+1"/>
			<xsl:with-param name="offset" select="$offset"/>
			<xsl:with-param name="last" select="$last"/>
			<xsl:with-param name="dow" select="$dow+1"/>
		</xsl:call-template>
	</xsl:if>
</xsl:template>



<!--
Pʂ̏
Zɓ()oB
AgendaGg\[gAGgoĂяoB
//-->
<xsl:template name="day">
	<xsl:param name="y"/>
	<xsl:param name="m"/>
	<xsl:param name="w"/>
	<xsl:param name="d"/>
	<xsl:param name="last"/>
	<xsl:param name="dow"/>

	<xsl:variable name="md" select="$m*100+$d"/>
	<xsl:variable name="ymd" select="$y*10000+$md"/>
	<xsl:variable name="y-m-d" select="concat($y,'-',substring(100+$m,2,2),'-',substring(100+$d,2,2))"/>
	<td>
		<xsl:choose>
			<xsl:when test="$dow=6">
				<xsl:attribute name="class">sat</xsl:attribute>
			</xsl:when>
			<xsl:when test="($dow mod 7)=0">
				<xsl:attribute name="class">sun</xsl:attribute>
			</xsl:when>
		</xsl:choose>
		<xsl:if test="$d&gt;0 and $d&lt;$last">
			<font class="day">
				<xsl:choose>
					<xsl:when test="$dow=6">
						<xsl:attribute name="class">sat</xsl:attribute>
					</xsl:when>
					<xsl:when test="($dow mod 7)=0">
						<xsl:attribute name="class">sun</xsl:attribute>
					</xsl:when>
				</xsl:choose>
				<xsl:value-of select="$d"/><p/>
			</font>
			<xsl:apply-templates select="entry[
			(substring(dateFrom,1,4)*10000+substring(dateFrom,6,2)*100+substring(dateFrom,9,2))&lt;=$ymd
			and (substring(dateTo,1,4)*10000+substring(dateTo,6,2)*100+substring(dateTo,9,2))&gt;=$ymd
				or @type='annv' and substring(dateFrom,1,4)&lt;=$y
				and (substring(dateFrom,6,2)*100+substring(dateFrom,9,2))=$md]">
				<xsl:sort select="dateFrom"/>
				<xsl:with-param name="ymd" select="$ymd"/>
				<xsl:with-param name="y" select="$y"/>
				<xsl:with-param name="y-m-d" select="$y-m-d"/>
			</xsl:apply-templates>
		</xsl:if>
	</td>
</xsl:template>



<!--
AgendaGg
eGgoB
//-->
<xsl:template match="entry">
	<xsl:param name="ymd"/>
	<xsl:param name="y"/>
	<xsl:param name="y-m-d"/>

	<font class="time">
		<xsl:choose>
			<xsl:when test="@type='appt'">
				<xsl:if test="substring(dateFrom,1,10)=$y-m-d">
					<xsl:value-of select="substring(dateFrom,12,5)"/>
					<xsl:text> </xsl:text>
				</xsl:if>
				<xsl:if test="not(substring(dateFrom,1,10)=$y-m-d)">
					<xsl:text>&gt;&gt;</xsl:text>
				</xsl:if>
			</xsl:when>
			<xsl:when test="@type='todo'">
				<xsl:text>T: </xsl:text>
				<xsl:if test="not(substring(dateFrom,1,10)=$y-m-d)">
					<xsl:text>&gt;&gt;</xsl:text>
				</xsl:if>
			</xsl:when>
			<xsl:when test="@type='evnt'">
				<xsl:text>E: </xsl:text>
				<xsl:if test="not(substring(dateFrom,1,10)=$y-m-d)">
					<xsl:text>&gt;&gt;</xsl:text>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>A: </xsl:text>
			</xsl:otherwise>
		</xsl:choose>
	</font>
	<xsl:call-template name="entry_text">
		<xsl:with-param name="y" select="$y"/>
	</xsl:call-template>
</xsl:template>



<!--
Gg̃eLXgo
eLXgoƁACxgnhݒsB
//-->
<xsl:template name="entry_text">
	<xsl:param name="y"/>

	<font class="entry" xsl:use-attribute-sets="a_entry">
		<xsl:attribute name="onClick">
			<xsl:text>detail(</xsl:text>
				"<xsl:value-of select="translate(summary,'&quot;','^')"/>",
				"<xsl:value-of select="@type"/>",
				"<xsl:value-of select="dateFrom"/>",
				"<xsl:value-of select="dateTo"/>",
				"<xsl:value-of select="alarm"/>",
				"<xsl:value-of select="alarm/@sound"/>",
				"<xsl:value-of select="translate(symbol,'&quot;','^')"/>",
				"<xsl:value-of select="anniv/@showYears"/>",
				"<xsl:call-template name="todo_list">
					<xsl:with-param name="id" select="todo/@project"/>
				</xsl:call-template>",
				"<xsl:value-of select="todo/@priority"/>",
				"<xsl:value-of select="@crossout"/>",
				"<xsl:value-of select="@tentative"/>"
			<xsl:text>)</xsl:text>
		</xsl:attribute>
		<xsl:choose>
			<xsl:when test="@crossout='true'">
				<del><xsl:value-of select="summary"/></del>
			</xsl:when>
			<xsl:when test="@tentative='true'">
				<font class="tentative" xsl:use-attribute-sets="a_entry">
					<xsl:value-of select="summary"/>
				</font>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="summary"/>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:if test="anniv/@showYears='start'">
			<font class="years">
				(<xsl:value-of select="substring(dateFrom,1,4)"/>~)
			</font>
		</xsl:if>
		<xsl:if test="anniv/@showYears='years'">
			<xsl:variable name="start" select="substring(dateFrom,1,4)"/>
			<font class="years">
				(<xsl:value-of select="$y - $start"/>years)
			</font>
		</xsl:if>
		<xsl:if test="anniv/@showYears='both'">
			<xsl:variable name="start" select="substring(dateFrom,1,4)"/>
			<font class="years">
				(<xsl:value-of select="substring(dateFrom,1,4)"/>~,
				<xsl:value-of select="$y - $start"/>years)
			</font>
		</xsl:if>
	</font>
	<xsl:if test="symbol!=''">
		<font class="symbol">
			[<xsl:value-of select="symbol"/>]
		</font>
	</xsl:if>
	<br/>
</xsl:template>



<!--
To-do list̎Q
IDTo-do list̃^Cg擾B
//-->
<xsl:template name="todo_list">
	<xsl:param name="id"/>
	<xsl:value-of select="translate(document('../agenda.xml')/epocAgenda/todoProject[@projectId=$id]/title,'&quot;','^')"/>
</xsl:template>


</xsl:stylesheet>
